<?php

class Paquetes {
    public function verPruebas() {
        $sql = "select * from pruebas";
        $res = Flight::db()->prepare($sql);
        $res->execute();
        $array = $res->fetchAll();
        $html = '';
        foreach ($array AS $k=>$v){
            $html .= '<div class="row">';
            $html .= '<div class="col-md-3"></div>';
            $html .= '<div class="col-md-9">';
            $html .= '<label><input type="checkbox" class="chkPrueba" data-id="'.$v['id'].'"> '.utf8_encode($v["prueba"]).'</label>';
            $html .= '</div></div>';
        }        
        return $html;
    }
    
    public function verEnvios($usuarioId){
        $sql = "SELECT 
                  pv.id AS id,
                  p.paquete AS paquete,
                  pv.version AS version,
                  pe.estado AS estado,
                  pe.color AS color,
                  if(ISNULL(u.id), '---', CONCAT(u.nombres, ' ', u.apellidos)) AS encargado
                FROM paquetes p
                INNER JOIN paquetes_versiones pv ON p.id = pv.paquete_id
                INNER JOIN paquetes_estados pe ON pv.paquete_estado_id = pe.id
                LEFT JOIN usuarios u ON pv.usuario_id = u.id
                WHERE p.usuario_id = $usuarioId";
        $res = Flight::db()->prepare($sql);
        $res->execute(array(
            'usuarioId' => $usuarioId
        ));
        $array = $res->fetchAll();
        $html = ''; #'<tr><td colspan="4">'.$sql.'</td></tr>';
        foreach ($array AS $k=>$v){
            $html .= '<tr style="background-color:'.$v["color"].'">';
            $html .= '<td>'.$v["paquete"].' '.$v["version"].'</td>';
            $html .= '<td>'.$v["estado"].'</td>';
            $html .= '<td>'.$v["encargado"].'</td>';
            $html .= '<td class="detalle"><a href="'.Flight::url('paquetes/detalle/'.$v["id"]).'">Ver detalle</td>';
            $html .= '</tr>';
        }        
        return $html;        
    }
    
    public function info($paqueteVersionId){
        $sql = "SELECT
	                p.paquete AS paquete,
                    p.repositorio AS repositorio,
                    pv.version AS version,
                    pe.estado AS estado,
                    pe.color AS color
                FROM paquetes_versiones pv
                INNER JOIN paquetes p ON pv.paquete_id = p.id
                INNER JOIN paquetes_estados pe ON pv.paquete_estado_id = pe.id
                WHERE pv.id = :paqueteVersionId";
        $res = Flight::db()->prepare($sql);
        $res->execute(array(
            "paqueteVersionId" => $paqueteVersionId
        ));
        $row = $res->fetch();
        $return = array(
            "paquete" => $row["paquete"],
            "repositorio" => $row["repositorio"],
            "version" => $row["version"],
            "estado" => $row["estado"],
            "color" => $row["color"]
        );
        
        $sql = "SELECT
	                s.fecha AS fecha,
                    a.accion AS accion,
                    CONCAT(u.nombres, ' ', u.apellidos) AS usuario,
                    s.comentario AS comentario
                FROM seguimientos s
                INNER JOIN usuarios u ON s.usuario_id = u.id
                INNER JOIN acciones a ON s.accion_id = a.id
                WHERE paquete_version_id = :paqueteVersionId";
        $res = Flight::db()->prepare($sql);
        $res->execute(array(
            "paqueteVersionId" => $paqueteVersionId
        ));
        $array = $res->fetchAll();
        $html = "";
        foreach ($array AS $k=>$v){
            $html .= '<tr>';
            $html .= '<td>'.$v["fecha"].'</td>';
            $html .= '<td>'.$v["accion"].'</td>';
            $html .= '<td>'.$v["usuario"].'</td>';
            $html .= '<td>'.$v["comentario"].'</td>';
            $html .= '</tr>';
        }
        $return["seguimiento"] = $html;
        return $return;
    }
    
    public function noAsignados(){
        $sql = "SELECT
	                pv.id as id,
                    p.paquete as paquete,
                    pv.version as version
                FROM paquetes_versiones pv
                INNER JOIN paquetes p ON pv.paquete_id = p.id
                WHERE pv.paquete_estado_id = 1";
        $res = Flight::db()->prepare($sql);
        $res->execute();
        $array = $res->fetchAll();
        $html = '<div class="table-responsive"><table class="table table-hover"><tr><th>Paquete</th><th>&nbsp;</th></tr>';
        $return = array();
        foreach ($array AS $k=>$v){
            $return[] = array(
                "id" => $v["id"],
                "paquete" => $v["paquete"],
                "version" => $v["version"]
            );
            $html .= '<tr>';
            $html .= '<td>'.$v["paquete"].' '.$v["version"].'</td>';
            $html .= '<td style="text-align:right"><a class="btn btn-success btnAsignar" data-id="'.$v["id"].'">Evaluar</a></td>';
            $html .= '</tr>';
        }
        $html .= '</table></div>';
        return $return;
    }
    
    public function evaluacion($paqueteVersionId){
        
    }
    
    public function paqueteAsignado($usuarioId){
        $sql = "select paquete_id from paquetes_versiones where usuario_id = :usuarioId and paquete_estado_id = 2";
        $res = Flight::db()->prepare($sql);
        $res->execute(array(
            "usuarioId" => $usuarioId
        ));
        if ($res->rowCount() > 0) {
            $row = $res->fetch();
            return $row["paquete_id"];
        } else {
            return 0;
        }
        
    }
    
    public function registrar() {
        # guardar paquete si aun no existe (paquetes)
        $paquete = $_POST["paquete"];
        $repositorio = $_POST["repositorio"];
        $usuarioId = $_SESSION["usuarioId"];
        $sqlPaquete = "INSERT INTO paquetes (paquete, repositorio, usuario_id) VALUES(:paquete, :repositorio, :usuarioId)";
        $resPaquete = Flight::db()->prepare($sqlPaquete);
        $resPaquete->execute(array(
            'paquete' => $paquete,
            'repositorio' => $repositorio,
            'usuarioId' => $usuarioId
        ));
        $paqueteId = Flight::db()->lastInsertid();
        if (!$resPaquete){
            return Flight::json(array(
                "error" => 1,
                "msg" => "Error al guardar la información del paquete",
                "info" => Flight::db()->errorInfo()
            ));
        }
        
        # guardar version del paquete (paquetes_versiones)
        $version = $_POST["version"];
        $comentarios = $_POST["comentarios"];
        $sqlVersion = "INSERT INTO paquetes_versiones (paquete_id, version, comentarios, usuario_id, paquete_estado_id) VALUES(:paquete_id, :version, :comentarios, 0, 1)";
        $resVersion = Flight::db()->prepare($sqlVersion);
        $resVersion->execute(array(
            'paquete_id' => $paqueteId,
            'version' => $version,
            'comentarios' => $comentarios
        ));
        $paqueteVersionId = Flight::db()->lastInsertid();
        if (!$resVersion){
            return Flight::json(array(
                "error" => 1,
                "msg" => "Error al guardar la información de la versión del paquete",
                "info" => Flight::db()->errorInfo()
            ));
        }
        
        # guardar pruebas del paquete (paquetes pruebas)
        $pruebas = $_POST["pruebas"];
        foreach ($pruebas AS $k=>$v){
            $pruebaId = $v[0];
            $resultado = $v[1];
            $sql = "INSERT INTO paquetes_pruebas (paquete_version_id, prueba_id, resultado_desarrollador) VALUES(:paquete_version_id, :prueba_id, :resultado_desarrollador)";
            $resPruebas = Flight::db()->prepare($sql);
            $resPruebas->execute(array(
                'paquete_version_id' => $paqueteVersionId,
                'prueba_id' => $pruebaId,
                'resultado_desarrollador' => $resultado
            ));
            if (!$resPruebas){
                return Flight::json(array(
                    "error" => 1,
                    "msg" => "Error al guardar la información de las pruebas del paquete",
                    "info" => Flight::db()->errorInfo()
                ));
            }
        }
        
        # guardar seguimiento
        $usuarioId = $_SESSION["usuarioId"];
        $comentario = '<a href="'.Flight::url('paquetes/detalle/'.$paqueteId).'">Ver detalle del paquete</a>';
        $sqlSeguimiento = "INSERT INTO seguimientos (fecha, paquete_version_id, accion_id, usuario_id, comentario) VALUES(NOW(), :paquete_version_id, 1, :usuario_id, :comentario)";
        $resSeguimiento = Flight::db()->prepare($sqlSeguimiento);
        $resSeguimiento->execute(array(
            'paquete_version_id' => $paqueteVersionId,
            'usuario_id' => $usuarioId,
            'comentario' => $comentario
        ));
        $seguimientoId = Flight::db()->lastInsertid();
        if (!$resSeguimiento){
            return Flight::json(array(
                "error" => 1,
                "msg" => "Error al guardar la información del seguimiento del paquete",
                "info" => Flight::db()->errorInfo()
            ));
        }
        
        return Flight::json(array(
            "paqueteId" => $paqueteId,
            "paqueteVersionId" => $paqueteVersionId,
            "seguimientoId" => $seguimientoId
        ));
    }
}
