<?php
session_start();
require 'vendor/autoload.php';

Flight::set('flight.views.path', 'app/vistas');
Flight::path('app/clases');
# Configuración de la base de datos (Cambiar por los valores correctos)
$db_host = "localhost";
$db_name = "propuestas";
$db_user = "root";
$db_pass = "123456";
Flight::register('db', 'PDO', array("mysql:host=$db_host;dbname=$db_propuestas", $db_user, $db_pass));

Flight::register('usuarios', 'Usuarios');
Flight::register('paquetes', 'Paquetes');
Flight::register('admin', 'Admin');

Flight::route('/', function(){
    Flight::render('index.php', array('name' => 'Bob'));
});

// Router para las acciones de usuario
Flight::route('GET|POST /usuarios/@accion', function($accion=""){
    switch($accion) {
        case "registrar":
            Flight::usuarios()->registrar();
            break;
        case "ingresar":
            Flight::usuarios()->ingresar();
            break;
    }
});

Flight::route('/desarrollador(/@accion)', function($accion){
    switch($accion){
        case "":
        case "inicio":
            Flight::render('desarrollador/index.php');
            break;
        case "enviar":
            Flight::render('desarrollador/enviar.php');
            break;
        case "envios":
            Flight::render('desarrollador/envios.php');
            break;
    }
});

Flight::route('/evaluador(/@accion)', function($accion){
    switch($accion){
        case "":
        case "inicio":
            Flight::render('evaluador/index.php');
            break;
        case "evaluados":
            Flight::render('evaluador/evaluados.php');
            break;
        default:
            print "error";
            break;
    }
});

Flight::route('/paquetes/@accion(/@param)', function($accion, $param){
    switch($accion){
        case "registrar":
            Flight::paquetes()->registrar();
            break;
        case "detalle":
            Flight::render('detalle.php', array('info'=>Flight::paquetes()->info($param)));
            break;
    }
});

Flight::route('/admin/@accion', function($accion){
    switch($accion){
        case "limpiardb":
            Flight::admin()->limpiarDb();
            break;
    }
});

Flight::route('/detalle/@paquete(/@estado)', function($paquete, $estado = ""){
    Flight::render('detalle.php', array("paquete" => $paquete, "estado" => $estado));
});

Flight::route('POST /get/git', function(){
    $cmd = 'git ls-remote --exit-code -h "'.$_POST["url"].'"';
    exec($cmd, $out, $return);
    echo Flight::json(array('exist' => ($return == 0 ? true : false)));
});

# Funciones Personalizadas
Flight::map('url', function($url = ""){
    return "http://".$_SERVER['HTTP_HOST'].substr(__DIR__, strlen($_SERVER[ 'DOCUMENT_ROOT' ]))."/$url";
});

Flight::start();
