-- Adminer 4.2.0 MySQL dump

SET NAMES utf8mb4;
SET time_zone = '+00:00';
SET foreign_key_checks = 0;
SET sql_mode = 'NO_AUTO_VALUE_ON_ZERO';

CREATE DATABASE `propuestas` /*!40100 DEFAULT CHARACTER SET utf8mb4 */;
USE `propuestas`;

DROP TABLE IF EXISTS `acciones`;
CREATE TABLE `acciones` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `accion` varchar(32) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

INSERT INTO `acciones` (`id`, `accion`) VALUES
(1,	'Nuevo paquete '),
(2,	'Paquete asignado a un evaluador'),
(3,	'Actualización de paquete'),
(4,	'Realizada Prueba'),
(5,	'Paquete Aprobado'),
(6,	'Paquete no Aprobado');

DROP TABLE IF EXISTS `menus`;
CREATE TABLE `menus` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `nombre` varchar(32) NOT NULL,
  `ruta` varchar(32) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

INSERT INTO `menus` (`id`, `nombre`, `ruta`) VALUES
(1,	'Enviar Software',	'desarrollador/enviar'),
(2,	'Mis Envíos',	'desarrollador/envios'),
(3,	'Inicio',	'desarrollador/inicio'),
(4,	'Salir',	'salir'),
(5,	'Inicio',	'evaluador/inicio'),
(6,	'Software Evaluado',	'evaluador/evaluados');

DROP TABLE IF EXISTS `paquetes`;
CREATE TABLE `paquetes` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `paquete` varchar(32) NOT NULL,
  `repositorio` varchar(128) NOT NULL,
  `usuario_id` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

DROP TABLE IF EXISTS `paquetes_estados`;
CREATE TABLE `paquetes_estados` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `estado` varchar(16) NOT NULL,
  `color` varchar(7) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

INSERT INTO `paquetes_estados` (`id`, `estado`, `color`) VALUES
(1,	'Pendiente',	'#ffe'),
(2,	'Asignado',	'#eef'),
(3,	'Aprobado',	'#efe'),
(4,	'Denegado',	'#fee');

DROP TABLE IF EXISTS `paquetes_pruebas`;
CREATE TABLE `paquetes_pruebas` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `paquete_version_id` int(11) NOT NULL,
  `prueba_id` int(11) NOT NULL,
  `resultado_desarrollador` tinyint(11) NOT NULL,
  `resultado_evaluador` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

DROP TABLE IF EXISTS `paquetes_versiones`;
CREATE TABLE `paquetes_versiones` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `paquete_id` int(11) NOT NULL,
  `version` varchar(16) NOT NULL,
  `comentarios` text NOT NULL,
  `usuario_id` int(11) NOT NULL COMMENT 'Id del usuario evaluador',
  `paquete_estado_id` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

DROP TABLE IF EXISTS `pruebas`;
CREATE TABLE `pruebas` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `prueba` varchar(128) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

INSERT INTO `pruebas` (`id`, `prueba`) VALUES
(1,	' El software pasó las pruebas de pbuilder'),
(2,	'El software pasó las pruebas de piupart'),
(3,	'El software pasó las pruebas de lintian'),
(4,	'no tiene una extensión mayor a 200 Mb'),
(5,	'El software no tarda más de 2 horas al momento de hacer una compilación o empaquetamiento'),
(6,	'El software no contiene componentes privativos'),
(7,	'El software ha sido debianizado correctamente');

DROP TABLE IF EXISTS `seguimientos`;
CREATE TABLE `seguimientos` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `fecha` datetime NOT NULL,
  `paquete_version_id` int(11) NOT NULL,
  `accion_id` int(11) NOT NULL,
  `usuario_id` int(11) NOT NULL,
  `comentario` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

DROP TABLE IF EXISTS `usuarios`;
CREATE TABLE `usuarios` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `nombres` varchar(32) NOT NULL,
  `apellidos` varchar(32) NOT NULL,
  `correo` varchar(32) NOT NULL,
  `clave` varchar(32) NOT NULL,
  `usuario_tipo_id` int(11) NOT NULL,
  `activo` int(11) NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

INSERT INTO `usuarios` (`id`, `nombres`, `apellidos`, `correo`, `clave`, `usuario_tipo_id`, `activo`) VALUES
(1,	'admin',	'admin',	'admin@admin',	'21232f297a57a5a743894a0e4a801fc3',	1,	1);

DROP TABLE IF EXISTS `usuarios_tipos`;
CREATE TABLE `usuarios_tipos` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `tipo_usuario` varchar(32) NOT NULL,
  `index` varchar(32) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

INSERT INTO `usuarios_tipos` (`id`, `tipo_usuario`, `index`) VALUES
(1,	'Administrador',	'administrador/'),
(2,	'Evaluador',	'evaluador/'),
(3,	'Desarrollador',	'desarrollador/');

DROP TABLE IF EXISTS `usuarios_tipos_menus`;
CREATE TABLE `usuarios_tipos_menus` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `menu_id` int(11) NOT NULL,
  `usuario_tipo_id` int(11) NOT NULL,
  `indice` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

INSERT INTO `usuarios_tipos_menus` (`id`, `menu_id`, `usuario_tipo_id`, `indice`) VALUES
(1,	3,	3,	1),
(2,	1,	3,	2),
(3,	2,	3,	3),
(4,	4,	3,	4),
(5,	5,	2,	1),
(6,	6,	2,	2),
(7,	4,	2,	3);

-- 2015-07-28 03:22:27
